#ifndef JIGSAW_H_INCLUDED
#define JIGSAW_H_INCLUDED
int Jigsaw(jig &sudoku)
{
    Rectangle Normal(175,175,270,270);
    Rectangle*Tiles[9][9];
    Rectangle*Dividers[9][9];
    Rectangle*Highlighters[9][9];//for highlighting
    Rectangle*Buttons[9];//Creation of buttons for providing input
    Rectangle*ButtonDividers[9];


    int Boxes[9][9];//for validating the entry of layout of jigsaw sudoku

    //Beginning of loop for creating tiles
    for(int i=0; i<=8; i++)
    {
        for(int j=0; j<=8; j++)
        {
            Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
            if (Tiles[i][j]==NULL)
            {
                return -1;
            }
            Tiles[i][j]->setFill();
            Tiles[i][j]->setColor(COLOR(255,255,255));
        }
    }
    //End of loop for creating tiles

    //Beginning of loop for creating borders of tiles
    for(int i=0; i<=8; i++)
    {
        for(int j=0; j<=8; j++)
        {
            Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
            if (Dividers[i][j]==NULL)
            {
                return -1;
            }

        }
    }
    //End of loop for creating borders of tiles


    //loop for creation of buttons
    for(int i=0; i<9; i++)
    {
        Buttons[i]=new Rectangle(140+40*i,380,30,30);
        if (Buttons[i]==NULL)
        {
            return -1;
        }
        Buttons[i]->setFill();

        if(i==0) Buttons[i]->setColor(COLOR(255,220,255));//providing the layout
        if(i==1) Buttons[i]->setColor(COLOR(255,164,181));


        if(i==2) Buttons[i]->setColor(COLOR(166,197,255));

        if(i==3) Buttons[i]->setColor(COLOR(255,255,176));
        if(i==4) Buttons[i]->setColor(COLOR(255,195,135));

        if(i==5) Buttons[i]->setColor(COLOR(215,215,215));
        if(i==6) Buttons[i]->setColor(COLOR(227,255,228));
        if(i==7) Buttons[i]->setColor(COLOR(255,219,189));
        if(i==8) Buttons[i]->setColor(COLOR(184,170,255));
    }



    //Beginning of the loop for bordering of buttons
    for(int i=0; i<9; i++)
    {
        ButtonDividers[i]=new Rectangle(140+40*i,380,30,30);
        if (ButtonDividers[i]==NULL)
        {
            return -1;
        }
        ButtonDividers[i]->setColor(COLOR(38,38,38));
    }
    //Putting numbers on buttons
    Text ButtonNumber1(140,380,"1");
    Text ButtonNumber2(180,380,"2");
    Text ButtonNumber3(220,380,"3");
    Text ButtonNumber4(260,380,"4");
    Text ButtonNumber5(300,380,"5");
    Text ButtonNumber6(340,380,"6");
    Text ButtonNumber7(380,380,"7");
    Text ButtonNumber8(420,380,"8");
    Text ButtonNumber9(460,380,"9");


    Rectangle freezeDivider(455,175,130,40);
    freezeDivider.setColor(COLOR(38,38,38));
    Text freezeWord(455,175,"Input");

    //Instruction for giving the layout
    Text Instruction1(300,20,"Give the layout of the Jigsaw Sudoku.Each button from 1 to 9 stands for a different box." );

    //Beginning of loop for giving the layout through colors which are represented by different buttons
    for(int j=0; j<=8; j++)
    {
        for(int i=0; i<=8; i++)
        {
            Highlighters[i][j]=new Rectangle(55+30*i,55+30*j,30,30);//for indicating the next tile to be filled
            if (Highlighters[i][j]==NULL)
            {
                cout<<"memory allocation failure";
                return -1;
            }
            Highlighters[i][j]->setColor(COLOR(90,66,255));

            while(true)//for holding the program till the user clicks on a button
            {
                int v=getClick();
                float x=v/65536;
                float y=v%65536;

                if(x>=125&&x<=155&&y>=365&&y<=395)//area of button "1"
                {
                    Tiles[i][j]->setColor(COLOR(255,220,255));

                    Boxes[i][j]=1;
                    break;
                }
                if(x>=165&&x<=195&&y>=365&&y<=395)//area of button "2"
                {
                    Tiles[i][j]->setColor(COLOR(255,164,181));

                    Boxes[i][j]=2;
                    break;
                }
                if(x>=205&&x<=235&&y>=365&&y<=395)//area of button "3"
                {
                    Tiles[i][j]->setColor(COLOR(166,197,255));

                    Boxes[i][j]=3;
                    break;
                }
                if(x>=245&&x<=275&&y>=365&&y<=395)//area of button "4"
                {
                    Tiles[i][j]->setColor(COLOR(255,255,176));

                    Boxes[i][j]=4;
                    break;
                }
                if(x>=285&&x<=315&&y>=365&&y<=395)//area of button "5"
                {
                    Tiles[i][j]->setColor(COLOR(255,195,135));

                    Boxes[i][j]=5;
                    break;
                }
                if(x>=325&&x<=355&&y>=365&&y<=395)//area of button "6"
                {
                    Tiles[i][j]->setColor(COLOR(215,215,215));

                    Boxes[i][j]=6;
                    break;
                }
                if(x>=365&&x<=395&&y>=365&&y<=395)//area of button "7"
                {
                    Tiles[i][j]->setColor(COLOR(227,255,228));

                    Boxes[i][j]=7;
                    break;
                }
                if(x>=405&&x<=435&&y>=365&&y<=395)//area of button "8"
                {
                    Tiles[i][j]->setColor(COLOR(255,219,189));

                    Boxes[i][j]=8;

                    break;

                }
                if(x>=445&&x<=475&&y>=365&&y<=395)//area of button "9"
                {
                    Tiles[i][j]->setColor(COLOR(184,170,255));

                    Boxes[i][j]=9;
                    break;
                }
            }
            delete Highlighters[i][j];//triggers movement of the highlighter accross the grid
        }
    }


    CopyGrid(Boxes, sudoku.box);//calling function CopyGrid for validating the layout
    bool ValidBoxes;
    ValidBoxes= sudoku.ValidBox();
    if(!ValidBoxes)
        //closes the program by giving an error message in case of invalid layout
    {
        Rectangle cover1(300,225,600,450);//for displaying error message and "EXIT"
        cover1.setColor(COLOR(255,255,255));
        cover1.setFill();
        Text error(300,225,"INVALID INPUT");
        Rectangle exit(300,305,130,50);
        Text EXIT(300,305,"EXIT");
        while(true)//for holding the program till user clicks on "EXIT"
        {
            int v=getClick();
            float x=v/65536;
            float y=v%65536;
            if(x>=235&&x<=365&&y>=285&&y<=335)
            {
                return 0;
            }

        }//end of while loop

    }

    //program continues in case of valid layout
    while(true)
        //holds the program till the user clicks the buttons
    {
        int u=getClick();
        float x=u/65536;
        float y=u%65536;
        if(x>=390&&x<=520&&y>=155&&y<=195)
        {
            break;
        }
    }
    //end of while loop

    Instruction1.hide();
    Rectangle NewButton(100,380,30,30);
    Rectangle NewButtonDivider(100,380,30,30);
    NewButton.setFill();
    NewButton.setColor(COLOR(215,215,215));
    NewButtonDivider.setColor(COLOR(38,38,38));
    Text ButtonNumber0(100,380,"0");
    for(int k=0; k<9; k++)
    {
        Buttons[k]->setColor(COLOR(215,215,215));
    }

    Text Instruction2(300,20,"Give the Input For The Sudoku('0' for blank)");

    int Grid[9][9];//for storing the input given through buttons
    int cx=0,cy=0,temp;
    int index=0;
    Text *input[81];


    for(int i=0; i>=0; i++)
        //start of loop for giving input
    {
        if(cx==0&&cy==9)
        {
            break;
        }
        int v=getClick();
        //waits for user to click
        int x=v/65536;
        int y=v%65536;
        //continuation for displaying the input
        if(y>=365&&y<=395&&cy<=8)
        {
            if(x>=100-15&&x<=100+15)//area of button '0'
            {
                input[index]=new Text(55+30*cx,55+30*cy,"0");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=0;
                //stores the value given in a specific grid
                if(cx<=8)
                    //makes sure that the next tile gets activated gets activated for giving input
                {
                    cx++;
                }
                if(cx==9)
                    //for the increment of row after a column has been completed
                {
                    cx=0;
                    cy++;
                }

            }
            if(x>=140-15&&x<=140+15)//area of button '1'
            {
                input[index]=new Text(55+30*cx,55+30*cy,"1");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=1;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }



            }
            if(x>=180-15&&x<=180+15)//area of button '2'
            {
                input[index]=new Text(55+30*cx,55+30*cy,"2");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=2;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }

            }
            if(x>=220-15&&x<=220+15)//area of button '3'
            {
                input[index]=new Text(55+30*cx,55+30*cy,"3");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=3;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }
            if(x>=260-15&&x<=260+15)//area of button '4'
            {
                input[index]=new Text(55+30*cx,55+30*cy,"4");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=4;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }
            if(x>=300-15&&x<=300+15)//area of button '5'
            {
                input[index]=new Text(55+30*cx,55+30*cy,"5");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=5;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }

            }
            if(x>=340-15&&x<=340+15)//area of button '6'
            {
                input[index]=new Text(55+30*cx,55+30*cy,"6");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=6;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }
            if(x>=380-15&&x<=380+15)//area of button '7'
            {
                input[index]=new Text(55+30*cx,55+30*cy,"7");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=7;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }
            if(x>=420-15&&x<=420+15)//area of button '8'
            {
                input[index]=new Text(55+30*cx,55+30*cy,"8");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=8;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }
            if(x>=460-15&&x<=460+15)//area of button '9'
            {
                input[index]=new Text(55+30*cx,55+30*cy,"9");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=9;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }

        }

    }
    //end of loop for giving input
    while(true)
    {
        int u=getClick();
        float x=u/65536;
        float y=u%65536;
        if(x>=455-65&&x<=455+65&&y<=175+20&&y>=175-20)
        {
            temp=6;
            break;//get out off the loop iff user clicks on "input"
        }
    }
    CopyGrid(Grid,sudoku.grid);
    bool ValidInput;
    ValidInput=ValidJ(sudoku) ;
    if(!ValidInput)
//closes the program by giving an error message in case of invalid layout
    {
        Rectangle cover1(300,225,600,450);
        //for displaying error message and "EXIT"
        cover1.setColor(COLOR(255,255,255));
        cover1.setFill();
        Text error(300,225,"INVALID INPUT");
        Rectangle exit(300,305,130,50);
        Text EXIT(300,305,"EXIT");
        while(true)
            //for holding the program till user clicks on "EXIT"
        {
            int v=getClick();
            float x=v/65536;
            float y=v%65536;
            if(x>=235&&x<=365&&y>=285&&y<=335)
            {
                return 0;
            }

        }
        //end of while loop

    }



    Rectangle cover1(300,225,600,450);
    //For showing the options on a blank screen
    cover1.setColor(COLOR(255,255,255));
    cover1.setFill();

    Rectangle rec1(300,100,130,40);
    Text t1(300,100,"SOLVE SUDOKU");
    Rectangle rec2(300,150,130,40);
    Text t2(300,150,"SHOW A TILE");
    Rectangle rec3(300,200,130,40);
    Text t3(300,200,"CHECK SOLUTION");
    Rectangle rec4(300,250,130,40);
    Text t4(300,250,"EXIT");


    while(true)
        //holds the program until a click
    {
        int v=getClick();
        int x=v/65536;
        int y=v%65536;
        if(x>=300-65&&x<=300+65&&y<=100+20&&y>=100-20)
        {
            temp=29;//for information that "solve sudoku" is selected
            break;//come out of the loop
        }

        if(x>=300-65&&x<=300+65&&y<=150+20&&y>=150-20)
        {
            temp=30;//"show a tile" is selected
            break;
        }



        if(x>=300-65&&x<=300+65&&y<=200+20&&y>=200-20)
        {
            temp=31;//"check solution" is selected
            break;
        }



        if(x>=300-65&&x<=300+65&&y<=250+20&&y>=250-20)
        {
            break;
            return 0;//in case of "EXIT"
        }

    }

    for(int index=0; index<9; index++)
    {
        delete ButtonDividers[index];//makes the buttons disappear
    }
    for(int index=0; index<9; index++)
    {
        delete Buttons[index];
    }

    return temp;



}

int temp29(jig &sudoku)//in case of "SOLVE SUDOKU"
{
    int a =JSudoku(sudoku);
    int Grid[9][9];
    int Boxes[9][9];
    CopyGrid(sudoku.grid,Grid);
    CopyGrid(sudoku.box,Boxes);


    switch(a)
    {
    case 1:
        //unique solution
    {


        Text t1(300,5,"Solution is unique");

        Rectangle Normal(175,175,270,270);
        Rectangle*Tiles[9][9];
        Rectangle*Dividers[9][9];


        //Beginning of loop for creating tiles
        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Tiles[i][j]==NULL)
                {
                    return -1;
                }
                Tiles[i][j]->setFill();
                Tiles[i][j]->setColor(COLOR(255,255,255));
            }
        }
        //End of loop for creating tiles

        //Beginning of loop for creating borders of tiles
        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Dividers[i][j]==NULL)
                {
                    return -1;
                }

            }
        }
        //End of loop for creating borders of tiles




        //Beginning of loop for giving the layout through colors which are represented by different buttons
        for(int j=0; j<=8; j++)
        {
            for(int i=0; i<=8; i++)
            {


                if(Boxes[i][j]==9)//indicates area of button "9"
                {
                    Tiles[i][j]->setColor(COLOR(184,170,255));
                }
                if(Boxes[i][j]==1)//area of button "1"
                {
                    Tiles[i][j]->setColor(COLOR(255,220,255));
                }
                if(Boxes[i][j]==2)//area of button "2"
                {
                    Tiles[i][j]->setColor(COLOR(255,164,181));

                }
                if(Boxes[i][j]==3)//area of button "3"
                {
                    Tiles[i][j]->setColor(COLOR(166,197,255));

                }
                if(Boxes[i][j]==4)//area of button "4"
                {
                    Tiles[i][j]->setColor(COLOR(255,255,176));

                }
                if(Boxes[i][j]==5)//area of button "5"
                {
                    Tiles[i][j]->setColor(COLOR(255,195,135));

                }
                if(Boxes[i][j]==6)//area of button "6"
                {
                    Tiles[i][j]->setColor(COLOR(215,215,215));

                }
                if(Boxes[i][j]==7)//area of button "7"
                {
                    Tiles[i][j]->setColor(COLOR(227,255,228));

                }
                if(Boxes[i][j]==8)//area of button "8"
                {
                    Tiles[i][j]->setColor(COLOR(255,219,189));

                }
            }
        }

        Text *input[81];
        int index=0;

        //beginning of loop for displaying the solution
        for(int cx=0; cx<9; cx++)
        {

            for(int cy=0; cy<9; cy++)
            {




                if(Grid[cx][cy]==0)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"0");
                    index++;
                }

                if(Grid[cx][cy]==1)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"1");
                    index++;
                }

                if(Grid[cx][cy]==2)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"2");
                    index++;
                }

                if(Grid[cx][cy]==3)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"3");
                    index++;
                }

                if(Grid[cx][cy]==4)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"4");
                    index++;
                }

                if(Grid[cx][cy]==5)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"5");
                    index++;
                }

                if(Grid[cx][cy]==6)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"6");
                    index++;
                }

                if(Grid[cx][cy]==7)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"7");
                    index++;
                }

                if(Grid[cx][cy]==8)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"8");
                    index++;
                }

                if(Grid[cx][cy]==9)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"9");
                    index++;
                }

            }

        }
        // end of loop for displaying the solution
        Rectangle r(400,225,100,30);
        Text t(400,225,"EXIT");

        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=400-50&&x<=400+50&&y<=225+15&&y>=225-15)
            {
                return 0;
            }

        }

    }
    break;

    case 0:
        //in case of multi solutions
    {

        Text t1(300,5,"Solution is not unique");

        Rectangle Normal(175,175,270,270);
        Rectangle*Tiles[9][9];
        Rectangle*Dividers[9][9];


        //Beginning of loop for creating tiles
        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Tiles[i][j]==NULL)
                {
                    return -1;
                }
                Tiles[i][j]->setFill();
                Tiles[i][j]->setColor(COLOR(255,255,255));
            }
        }
        //End of loop for creating tiles




        //Beginning of loop for creating borders of tiles
        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Dividers[i][j]==NULL)
                {
                    return -1;
                }

            }
        }
        //End of loop for creating borders of tiles


        //Beginning of loop for giving the layout through colors which are represented by different buttons
        for(int j=0; j<=8; j++)
        {
            for(int i=0; i<=8; i++)
            {


                if(Boxes[i][j]==9)//area of button "9"
                {
                    Tiles[i][j]->setColor(COLOR(184,170,255));
                }
                if(Boxes[i][j]==1)//area of button "1"
                {
                    Tiles[i][j]->setColor(COLOR(255,220,255));
                }
                if(Boxes[i][j]==2)//area of button "2"
                {
                    Tiles[i][j]->setColor(COLOR(255,164,181));

                }
                if(Boxes[i][j]==3)//area of button "3"
                {
                    Tiles[i][j]->setColor(COLOR(166,197,255));

                }
                if(Boxes[i][j]==4)//area of button "4"
                {
                    Tiles[i][j]->setColor(COLOR(255,255,176));

                }
                if(Boxes[i][j]==5)//area of button "5"
                {
                    Tiles[i][j]->setColor(COLOR(255,195,135));

                }
                if(Boxes[i][j]==6)//area of button "6"
                {
                    Tiles[i][j]->setColor(COLOR(215,215,215));

                }
                if(Boxes[i][j]==7)//area of button "7"
                {
                    Tiles[i][j]->setColor(COLOR(227,255,228));

                }
                if(Boxes[i][j]==8)//area of button "8"
                {
                    Tiles[i][j]->setColor(COLOR(255,219,189));

                }
            }
        }
        //Beginning of loop for giving the layout through colors which are represented by different buttons


        Text *input[81];
        int index=0;


        for(int cx=0; cx<9; cx++)
        {

            for(int cy=0; cy<9; cy++)
            {




                if(Grid[cx][cy]==0)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"0");
                    index++;
                }

                if(Grid[cx][cy]==1)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"1");
                    index++;
                }

                if(Grid[cx][cy]==2)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"2");
                    index++;
                }

                if(Grid[cx][cy]==3)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"3");
                    index++;
                }

                if(Grid[cx][cy]==4)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"4");
                    index++;
                }

                if(Grid[cx][cy]==5)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"5");
                    index++;
                }

                if(Grid[cx][cy]==6)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"6");
                    index++;
                }

                if(Grid[cx][cy]==7)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"7");
                    index++;
                }

                if(Grid[cx][cy]==8)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"8");
                    index++;
                }

                if(Grid[cx][cy]==9)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"9");
                    index++;
                }

            }

        }

        Rectangle r(400,225,100,30);
        Text t(400,225,"EXIT");

        while(true)
            //holds the program till "EXIT" is selected
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=400-50&&x<=400+50&&y<=225+15&&y>=225-15)
            {
                return 0;
            }

        }


    }
    break;

    case -1:
        //if no solution exists
    {

        Text t1(300,225,"No Solution exists");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }

        }

    }

    }
}
//program returns to main

int temp30(jig sudoku)//in case of "SHOW A TILE"
{
    int A[9][9];
    CopyGrid(sudoku.grid,A);
    int Boxes[9][9];
    CopyGrid(sudoku.box,Boxes);

    Text t(380,175,"select the tile");
    wait(0.5);

    Rectangle Normal(175,175,270,270);
    Rectangle*Tiles[9][9];
    Rectangle*Dividers[9][9];


    //Beginning of loop for creating tiles
    for(int i=0; i<=8; i++)
    {
        for(int j=0; j<=8; j++)
        {
            Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
            if (Tiles[i][j]==NULL)
            {
                return -1;
            }
            Tiles[i][j]->setFill();
            Tiles[i][j]->setColor(COLOR(255,255,255));
        }
    }
    //End of loop for creating tiles

    //Beginning of loop for creating borders of tiles
    for(int i=0; i<=8; i++)
    {
        for(int j=0; j<=8; j++)
        {
            Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
            if (Dividers[i][j]==NULL)
            {
                return -1;
            }

        }
    }
    //End of loop for creating borders of tiles




    //Beginning of loop for giving the layout through colors which are represented by different buttons
    for(int j=0; j<=8; j++)
    {
        for(int i=0; i<=8; i++)
        {


            if(Boxes[i][j]==9)//area of button "9"
            {
                Tiles[i][j]->setColor(COLOR(184,170,255));
            }
            if(Boxes[i][j]==1)//area of button "1"
            {
                Tiles[i][j]->setColor(COLOR(255,220,255));
            }
            if(Boxes[i][j]==2)//area of button "2"
            {
                Tiles[i][j]->setColor(COLOR(255,164,181));

            }

            if(Boxes[i][j]==3)//area of button "3"
            {
                Tiles[i][j]->setColor(COLOR(166,197,255));

            }
            if(Boxes[i][j]==4)//area of button "4"
            {
                Tiles[i][j]->setColor(COLOR(255,255,176));

            }
            if(Boxes[i][j]==5)//area of button "5"
            {
                Tiles[i][j]->setColor(COLOR(255,195,135));

            }
            if(Boxes[i][j]==6)//area of button "6"
            {
                Tiles[i][j]->setColor(COLOR(215,215,215));

            }
            if(Boxes[i][j]==7)//area of button "7"
            {
                Tiles[i][j]->setColor(COLOR(227,255,228));

            }
            if(Boxes[i][j]==8)//area of button "8"
            {
                Tiles[i][j]->setColor(COLOR(255,219,189));

            }
        }
    }

    Text *input[81];
    int index=0;

    //beginning of loop for displaying sudoku along
    for(int cx=0; cx<9; cx++)
    {

        for(int cy=0; cy<9; cy++)
        {
            if(A[cx][cy]==0)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"0");
                index++;
            }

            if(A[cx][cy]==1)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"1");
                index++;
            }

            if(A[cx][cy]==2)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"2");
                index++;
            }

            if(A[cx][cy]==3)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"3");
                index++;
            }

            if(A[cx][cy]==4)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"4");
                index++;
            }

            if(A[cx][cy]==5)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"5");
                index++;
            }

            if(A[cx][cy]==6)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"6");
                index++;
            }

            if(A[cx][cy]==7)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"7");
                index++;
            }

            if(A[cx][cy]==8)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"8");
                index++;
            }

            if(A[cx][cy]==9)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"9");
                index++;
            }

        }

    }

    //end of loop for displaying the tile along with the input

    int i,j;
    while(true)
    {

        int v=getClick();
        int x=v/65536;
        int y=v%65536;
        i=(x-40)/30;
        j=(y-40)/30;
        if(i>=0&&i<9&&j>=0&&j<9)
        {
            Rectangle r(55+30*i,55+30*j,30,30);
            r.setColor(COLOR(234,255,79));
            wait(1);
            for(int i=0; i<9; i++)
            {
                for(int j=0; j<9; j++)
                {
                    if(Tiles[i][j]!=NULL&&Dividers[i][j]!=NULL)
                    {
                        delete Tiles[i][j];
                        delete Dividers[i][j];
                    }
                }
            }

            for(int i=0; i<81; i++)
            {
                if(input[i]==NULL)
                {
                    return 0;
                }
                if(input[i]!=NULL)
                {
                    delete input[i];
                }
            }

            Normal.hide();
            t.hide();
        }
        break;
    }

    if (A[i][j]!=0)
    {
        Text t1(300,225,"Tile already displayed");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
            //for holding the program till "EXIT" is selected
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }

        }//end of while loop
    }



    int a = JSudoku(sudoku);//calls JSudoku to know whether no solution or multi solution or unique solution
    switch(a)
    {
    case -1://case of no solution
    {
        Rectangle cover4(300,225,600,450);
        cover4.setColor(COLOR(255,255,255));
        cover4.setFill();
        Text t1(300,225,"No Solution exists");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;//program exits
            }
        }
    }
    break;


    case 0://case of multiple solutions
    {
        Rectangle cover3(300,225,600,450);
        cover3.setColor(COLOR(255,255,255));
        cover3.setFill();
        Text t1(300,225,"Multiple Solutions Possible");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;//program exits
            }
        }//end of while loop
    }
    break;

    case 1:
    {
        A[i][j]=sudoku.grid[i][j];


        int Boxes[9][9];
        CopyGrid(sudoku.box,Boxes);

        Rectangle Normal(175,175,270,270);
        Rectangle*Tiles[9][9];
        Rectangle*Dividers[9][9];


        //Beginning of loop for creating tiles
        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Tiles[i][j]==NULL)
                {
                    return -1;
                }
                Tiles[i][j]->setFill();
                Tiles[i][j]->setColor(COLOR(255,255,255));
            }
        }
        //End of loop for creating tiles

        //Beginning of loop for creating borders of tiles
        for(int i=0; i<=8; i++)
        {
            for(int j=0; j<=8; j++)
            {
                Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
                if (Dividers[i][j]==NULL)
                {
                    return -1;
                }

            }
        }
        //End of loop for creating borders of tiles




        //Beginning of loop for giving the layout through colors which are represented by different buttons
        for( j=0; j<=8; j++)
        {
            for( i=0; i<=8; i++)
            {


                if(Boxes[i][j]==9)//area of button "9"
                {
                    Tiles[i][j]->setColor(COLOR(184,170,255));
                }
                if(Boxes[i][j]==1)//area of button "1"
                {
                    Tiles[i][j]->setColor(COLOR(255,220,255));
                }
                if(Boxes[i][j]==2)//area of button "2"
                {
                    Tiles[i][j]->setColor(COLOR(255,164,181));

                }
                if(Boxes[i][j]==3)//area of button "3"
                {
                    Tiles[i][j]->setColor(COLOR(166,197,255));

                }
                if(Boxes[i][j]==4)//area of button "4"
                {
                    Tiles[i][j]->setColor(COLOR(255,255,176));

                }
                if(Boxes[i][j]==5)//area of button "5"
                {
                    Tiles[i][j]->setColor(COLOR(255,195,135));

                }
                if(Boxes[i][j]==6)//area of button "6"
                {
                    Tiles[i][j]->setColor(COLOR(215,215,215));

                }
                if(Boxes[i][j]==7)//area of button "7"
                {
                    Tiles[i][j]->setColor(COLOR(227,255,228));

                }
                if(Boxes[i][j]==8)//area of button "8"
                {
                    Tiles[i][j]->setColor(COLOR(255,219,189));

                }
            }
        }


        Text *input[81];
        int index=0;


        for(int cx=0; cx<9; cx++)
        {

            for(int cy=0; cy<9; cy++)
            {




                if(A[cx][cy]==0)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"0");
                    index++;
                }

                if(A[cx][cy]==1)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"1");
                    index++;
                }

                if(A[cx][cy]==2)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"2");
                    index++;
                }

                if(A[cx][cy]==3)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"3");
                    index++;
                }

                if(A[cx][cy]==4)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"4");
                    index++;
                }

                if(A[cx][cy]==5)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"5");
                    index++;
                }

                if(A[cx][cy]==6)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"6");
                    index++;
                }

                if(A[cx][cy]==7)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"7");
                    index++;
                }

                if(A[cx][cy]==8)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"8");
                    index++;
                }

                if(A[cx][cy]==9)
                {
                    input[index]=new Text(55+30*cx,55+30*cy,"9");
                    index++;
                }

            }
        }



        Rectangle r1(400,200,100,40);
        Text t1(400,200,"Solve Sudoku");
        Rectangle r2(400,275,50,30);
        Text t2(400,275,"Exit");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=400-25&&x<=400+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }
            if(x>=400-50&&x<=400+50&&y<=200+20&&y>=200-20)
            {
                r1.hide();
                r2.hide();
                t1.hide();
                t2.hide();
                Rectangle cover8(300,225,600,450);
                cover8.setColor(COLOR(255,255,255));
                cover8.setFill();
                return temp29(sudoku);
            }
        }




    }



    }
}
//return of temp30 i.e for showing tile


int temp31(jig &sudoku)//Check Solution
{
    int Boxes[9][9];//for validating the entry of layout of jigsaw sudoku
    CopyGrid(sudoku.box,Boxes);
    jig solved;
    CopyGrid(sudoku.box,solved.box);


    Rectangle Normal(175,175,270,270);
    Rectangle*Tiles[9][9];
    Rectangle*Dividers[9][9];
    Rectangle*Highlighters[9][9];



    //Beginning of loop for creating tiles
    for(int i=0; i<=8; i++)
    {
        for(int j=0; j<=8; j++)
        {
            Tiles[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
            if (Tiles[i][j]==NULL)
            {
                return -1;
            }
            Tiles[i][j]->setFill();
            Tiles[i][j]->setColor(COLOR(255,255,255));
        }
    }

    for(int i=0; i<=8; i++)
    {
        for(int j=0; j<=8; j++)
        {
            Dividers[i][j]=new Rectangle(55+30*i,55+30*j,30,30);
            if (Dividers[i][j]==NULL)
            {
                return -1;
            }

        }
    }
    //End of loop for creating borders of tiles

    //Creation of buttons for providing input
    Rectangle*Buttons[10];
    //loop for creation of buttons
    for(int i=0; i<=9; i++)
    {
        Buttons[i]=new Rectangle(100+40*i,380,30,30);
        if (Buttons[i]==NULL)
        {
            return -1;
        }
        Buttons[i]->setFill();
        Buttons[i]->setColor(COLOR(215,215,215));
    }

    Rectangle*ButtonDividers[10];


    //Beginning of the loop for bordering of buttons
    for(int i=0; i<10; i++)
    {
        ButtonDividers[i]=new Rectangle(100+40*i,380,30,30);
        if (ButtonDividers[i]==NULL)
        {
            return -1;
        }
        ButtonDividers[i]->setColor(COLOR(38,38,38));
    }
    //Putting numbers on buttons
    Text ButtonNumber0(100,380,"0");
    Text ButtonNumber1(140,380,"1");
    Text ButtonNumber2(180,380,"2");
    Text ButtonNumber3(220,380,"3");
    Text ButtonNumber4(260,380,"4");
    Text ButtonNumber5(300,380,"5");
    Text ButtonNumber6(340,380,"6");
    Text ButtonNumber7(380,380,"7");
    Text ButtonNumber8(420,380,"8");
    Text ButtonNumber9(460,380,"9");


    Rectangle freezeDivider(455,175,130,40);
    freezeDivider.setColor(COLOR(38,38,38));
    Text freezeWord(455,175,"Input");



    Text Instruction2(300,20,"Give the Input For The Sudoku");

    int Grid[9][9];
    int cx=0,cy=0,temp;
    int index=0;
    Text *input[81];
    //start of loop for creating the tiles
    for(int j=0; j<=8; j++)
    {
        for(int i=0; i<=8; i++)
        {


            if(Boxes[i][j]==9)//area of button "9"
            {
                Tiles[i][j]->setColor(COLOR(184,170,255));
            }
            if(Boxes[i][j]==1)//area of button "1"
            {
                Tiles[i][j]->setColor(COLOR(255,220,255));
            }
            if(Boxes[i][j]==2)//area of button "2"
            {
                Tiles[i][j]->setColor(COLOR(255,164,181));

            }
            if(Boxes[i][j]==3)//area of button "3"
            {
                Tiles[i][j]->setColor(COLOR(166,197,255));

            }
            if(Boxes[i][j]==4)//area of button "4"
            {
                Tiles[i][j]->setColor(COLOR(255,255,176));

            }
            if(Boxes[i][j]==5)//area of button "5"
            {
                Tiles[i][j]->setColor(COLOR(255,195,135));

            }
            if(Boxes[i][j]==6)//area of button "6"
            {
                Tiles[i][j]->setColor(COLOR(215,215,215));

            }
            if(Boxes[i][j]==7)//area of button "7"
            {
                Tiles[i][j]->setColor(COLOR(227,255,228));

            }
            if(Boxes[i][j]==8)//area of button "8"
            {
                Tiles[i][j]->setColor(COLOR(255,219,189));

            }
        }
    }//end of loop for creating the tiles

    for(int i=0; i>=0; i++)
        //start of loop for giving input
    {

        int v=getClick();
        int x=v/65536;
        int y=v%65536;
        if(x>=455-65&&x<=455+65&&y<=175+20&&y>=175-20)
        {
            temp=6;
            break;
        }
        if(y>=365&&y<=395&&cy<=8)
        {
            if(x>=100-15&&x<=100+15)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"0");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=0;
                //stores the value given in a specific grid
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }

            }
            if(x>=140-15&&x<=140+15)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"1");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=1;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }



            }
            if(x>=180-15&&x<=180+15)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"2");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=2;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }

            }
            if(x>=220-15&&x<=220+15)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"3");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=3;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }
            if(x>=260-15&&x<=260+15)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"4");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=4;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }
            if(x>=300-15&&x<=300+15)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"5");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=5;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }

            }
            if(x>=340-15&&x<=340+15)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"6");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=6;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }
            if(x>=380-15&&x<=380+15)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"7");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=7;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }
            if(x>=420-15&&x<=420+15)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"8");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=8;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }
            if(x>=460-15&&x<=460+15)
            {
                input[index]=new Text(55+30*cx,55+30*cy,"9");
                if(input[index]==NULL)
                {
                    cout<<"memory allocation failure";
                    return -1;
                }
                else
                    index++;
                Grid[cx][cy]=9;
                if(cx<=8)
                {
                    cx++;
                }
                if(cx==9)
                {
                    cx=0;
                    cy++;
                }
            }

        }

    }



    Rectangle r5(300,225,600,450);
    r5.setFill();
    r5.setColor(COLOR(255,255,255));




    CopyGrid(Grid,solved.grid);

    int b = CheckJSudoku(sudoku,solved);//function call for checking the solution of Jigsaw
    switch(b)
    {
    case 1:
        //case of correct solution
    {
        Rectangle cover5(300,225,600,450);
        cover5.setColor(COLOR(255,255,255));
        cover5.setFill();
        Text t1(300,225,"Solution is Correct");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }

        }
    }
    break;

    case 0:
        //case of incorrect solution
    {
        Rectangle cover7(300,225,600,450);
        cover7.setColor(COLOR(255,255,255));
        cover7.setFill();
        Text t1(300,225,"Solution is Incorrect");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }

        }

    }
    break;

    case -1:
        //case of incomplete solution like not inputting all elements or inputting some elements as zeros
    {
        Rectangle cover6(300,225,600,450);
        cover6.setColor(COLOR(255,255,255));
        cover6.setFill();
        Text t1(300,225,"Solution is Incomplete");
        Rectangle r(300,275,50,30);
        Text t2(300,275,"EXIT");
        while(true)
            //holds the program till user selects EXIT
        {

            int v=getClick();
            int x=v/65536;
            int y=v%65536;
            if(x>=300-25&&x<=300+25&&y<=275+15&&y>=275-15)
            {
                return 0;
            }

        }

    }
    }



}

#endif // JIGSAW_H_INCLUDED
