#include <iostream>
using namespace std;

#ifndef SUDOKU_H_INCLUDED
#define SUDOKU_H_INCLUDED

//object for jigsaw sudoku
struct jig
{
    public:
    int box[9][9];
//for storing configuration of boxes
    int grid [9][9];
//for storing problem or solution sudoku grid
    bool present [9][10];
//for storing the entries present in boxes

//constructor
    jig()
    {
        for(int i=0;i<9;i++)
        {
            for(int j=0;j<9;j++)
            {
                box[i][j]=0;
                grid[i][j]=0;
                present[i][j]=false;
            }
            present[i][9]=false;
        }
    return ;
    }

//validation of boxes
    bool ValidBox()
    {
        int elem;
        int box_tile[9]={0,0,0,0,0,0,0,0,0};
        bool b1, b2, b3, b4;
        for(int index1=0;index1<9;index1++)
        {
            for(int index2=0;index2<9;index2++)
            {
                elem = box[index1][index2];
                if ((elem<1)||(elem>10))
                    {
                        cout<<"Invalid jigsaw sudoku boxes";
                        return 0;
                    }
                b1 = (((index1>0)&&(elem==box[index1-1][index2]))?1:0);
                b2 = (((index2>0)&&(elem==box[index1][index2-1]))?1:0);
                b3 = (((index1<8)&&(elem==box[index1+1][index2]))?1:0);
                b4 = (((index2<8)&&(elem==box[index1][index2+1]))?1:0);
                box_tile[elem-1]++;
                if(!(b1||b2||b3||b4)){cout<<"Invalid jigsaw sudoku boxes"; return 0;}
            }
        }

         for(int index=0;index<9;index++)
         {
             if(box_tile[index]!=9){cout<<"Invalid jigsaw sudoku boxes"; return 0;}
         }
        return 1;
    }

//inputs present and validates the grid
    bool InputPresent()
    {
    //Re-initialisation
        for(int i=0;i<9;i++)
        {
            for(int j=0;j<10;j++)
            {

                present[i][j]=false;
            }

        }

        int grid_num, box_num;
        for(int index1=0;index1<9;index1++)
        {
            for(int index2=0;index2<9;index2++)
            {
                box_num = box[index1][index2]-1;
                grid_num = grid[index1][index2];
                if ((present[box_num][grid_num])&&(grid_num!=0))
                {
                    cout<<"Invalid Input";
                    return false;
                }
                else
                {
                    present[box_num][grid_num]=true;
                }
            }
        }
        return true;
    }

};

int InputGrid(int sudoku_grid[9][9]);
bool SolveNSudoku(int sudoku_grid[9][9],int a);
bool SolveDSudoku(int sudoku_grid[9][9], int a);
bool SolveWSudoku(int sudoku_grid[9][9], int a);
bool SolveJSudoku(jig &sudoku, int a);
bool FindBlank(int sudoku_grid[9][9], int &row, int &col);
bool CheckNumN(int sudoku_grid[9][9], int row, int col, int num);
bool CheckNumD(int sudoku_grid[9][9], int row, int col, int num);
bool CheckNumW(int sudoku_grid[9][9], int row, int col, int num);
bool CheckNumJ(jig sudoku, int row, int col, int num);
bool CheckRow(int sudoku_grid[9][9], int row, int col, int num);
bool CheckCol(int sudoku_grid[9][9], int row, int col, int num);
bool CheckDia1(int sudoku_grid[9][9],int row, int col, int num);
bool CheckDia2(int sudoku_grid[9][9],int row, int col, int num);
bool CheckBox(int sudoku_grid[9][9],int row, int col, int rowstart, int colstart, int num);
void DisplaySudoku(int sudoku_grid[9][9]);
int CheckNSudoku(int sudoku_grid[9][9],int solved_grid[9][9]);
int CheckDSudoku(int sudoku_grid[9][9],int solved_grid[9][9]);
int CheckWSudoku(int sudoku_grid[9][9],int solved_grid[9][9]);
int CheckJSudoku(jig &sudoku,jig &solved);
bool CheckSame(int grid1[9][9], int grid2[9][9]);
int NSudoku(int sudoku_grid[9][9]);
int DSudoku(int sudoku_grid[9][9]);
int WSudoku(int sudoku_grid[9][9]);
int JSudoku(jig &sudoku);
void CopyGrid(int grid[9][9], int copy_grid[9][9]);
bool ValidN(int sudoku_grid[9][9]);
bool ValidD(int sudoku_grid[9][9]);
bool ValidW(int sudoku_grid[9][9]);
bool ValidJ(jig &sudoku);

//Copies one grid to another grid
void CopyGrid(int grid[9][9], int copy_grid[9][9])
{
    int i, j;
    for (i = 0; i < 9; i++)
    {
        for (j = 0; j < 9; j++)
        {
        copy_grid[i][j] = grid[i][j];
        }
    }
}
//Inputs the grid
int InputGrid(int sudoku_grid[9][9])
{
    cout<< "Input the sudoku grid (0 for blank box)";
    int index1, index2;
    for (index1 = 0; index1 < 9; index1++)
    {
        for (int index2 = 0; index2 < 9; index2++)
        {
            cin>>sudoku_grid[index1][index2];
            if ((sudoku_grid[index1][index2]<0)||
            (sudoku_grid[index1][index2]>9))
            {
                cout<<"Invalid Input";
                return 1;
            }
        }
    }
    cout<<"Given sudoku is:"<<endl;
    DisplaySudoku(sudoku_grid);
    return 0;
}

/* Takes a partially filled normal sudoku grid and attempts to assign
values to all unassigned locations in such a way to meet the requirements
for specified Sudoku solution */

bool SolveNSudoku(int sudoku_grid[9][9], int a)
{
    int row, col;
// If there is no unassigned location then sudoku has been solved
    if (!(FindBlank(sudoku_grid, row, col)))
    {
        return true;
    }
    int num;
// consider digits 1 to 9
    for (int i=0, num=5-4*a; i<9; i++, num+=a)
    {
        if (CheckNumN(sudoku_grid, row, col, num))
        {
//given value may form the solution as it is valid
// make temporary assignment
            sudoku_grid[row][col] = num;
//apply recursion and call function SolveNSudoku again
            if (SolveNSudoku(sudoku_grid,a))
            {
//sudoku is solved
                return true;
            }
// given value does not form solution
// undo temporary assignment
            sudoku_grid[row][col] = 0;
        }
    }
    return false;
// this triggers backtracking
}

/* Takes a partially filled diagonal sudoku grid and attempts to assign
values to all unassigned locations in such a way to meet the requirements
for specified Sudoku solution */

bool SolveDSudoku(int sudoku_grid[9][9], int a)
{

    int row, col;
// If there is no unassigned location then sudoku has been solved
    if (!(FindBlank(sudoku_grid, row, col)))
    {
        return true;
    }
    int num;
// consider digits 1 to 9
    for (int i=0, num=5-4*a; i<9; i++, num+=a)
    {
        if (CheckNumD(sudoku_grid, row, col, num))
        {
//given value may form the solution as it is valid
// make temporary assignment
            sudoku_grid[row][col] = num;
//apply recursion and call function SolveNSudoku again
            if (SolveDSudoku(sudoku_grid,a))
            {
//sudoku is solved
                return true;
            }
// given value does not form solution
// undo temporary assignment
            sudoku_grid[row][col] = 0;
        }
    }
    return false;
// this triggers backtracking
}

/* Takes a partially filled window sudoku grid and attempts to assign
values to all unassigned locations in such a way to meet the requirements
for specified Sudoku solution */

bool SolveWSudoku(int sudoku_grid[9][9], int a)
{

    int row, col;
// If there is no unassigned location then sudoku has been solved
    if (!(FindBlank(sudoku_grid, row, col)))
    {
        return true;
    }
    int num;
// consider digits 1 to 9
    for (int i=0, num=5-4*a; i<9; i++, num+=a)
    {
        if (CheckNumW(sudoku_grid, row, col, num))
        {
//given value may form the solution as it is valid
// make temporary assignment
            sudoku_grid[row][col] = num;
//apply recursion and call function SolveNSudoku again
            if (SolveWSudoku(sudoku_grid,a))
            {
//sudoku is solved
                return true;
            }
// given value does not form solution
// undo temporary assignment
            sudoku_grid[row][col] = 0;
        }
    }
    return false;
// this triggers backtracking
}

/* Takes a partially filled jigsaw sudoku grid and attempts to assign
values to all unassigned locations in such a way to meet the requirements
for specified Sudoku solution */

bool SolveJSudoku(jig &sudoku, int a)
{
//box validation has been done

    int row, col;
// If there is no unassigned location then sudoku has been solved
    if (!(FindBlank(sudoku.grid, row, col)))
    {
        return true;
    }
    int num;
    int box_num = sudoku.box[row][col]-1;
// consider digits 1 to 9
    for (int i=0, num=5-4*a; i<9; i++, num+=a)
    {
        if ((CheckNumJ(sudoku, row, col, num))&&(!sudoku.present[box_num][num]))
        {
//given value may form the solution as it is valid
// make temporary assignment
            sudoku.grid[row][col] = num;
            sudoku.present[box_num][num]=true;
//apply recursion and call function SolveJSudoku again
            if (SolveJSudoku(sudoku,a))
            {
//sudoku is solved
                return true;
            }
// given value does not form solution
// undo temporary assignment
            sudoku.grid[row][col] = 0;
            sudoku.present[box_num][num]=false;
        }
    }
    return false;
// this triggers backtracking
}

/* Searches the sudoku_grid to find an entry that is blank. If
found, the reference parameters row, col will be set the location
that is blank, and true is returned. If no blank entries
remain, false is returned. */

bool FindBlank(int sudoku_grid[9][9], int &row, int &col)
{
    for (row = 0; row < 9; row++)
    {
        for (col = 0; col < 9; col++)
        {
            if (sudoku_grid[row][col] == 0)
            {
//tile is blank
                return true;
            }
        }
    }
//no blank tile
    return false;
}

/* Returns a bool which indicates whether any assigned entry
in the specified tile is valid for normal sudoku or not. */
bool CheckNumN(int sudoku_grid[9][9], int row, int col, int num)
{
//Check if num is not already placed in current row, coloumn and box
    return ((!CheckRow(sudoku_grid, row, col, num))&&
            (!CheckCol(sudoku_grid, row, col, num))&&
            (!CheckBox(sudoku_grid, row, col, 3*(row/3), 3*(col/3), num)));

}

/* Returns a bool which indicates whether any assigned entry
in the specified tile is valid for diagonal sudoku or not. */
bool CheckNumD(int sudoku_grid[9][9], int row, int col, int num)
{
//Check if num is not already placed in current row, coloumn and box
    if (row==col)
    {
//tile belongs to diagonal 1
        if(row==4)
        {
//tile belongs to diagonal 2 as well
            return ((!CheckRow(sudoku_grid, row, col, num))&&
            (!CheckCol(sudoku_grid, row, col, num))&&
            (!CheckDia1(sudoku_grid, row, col, num))&&
            (!CheckDia2(sudoku_grid, row, col, num))&&
            (!CheckBox(sudoku_grid, row, col, 3*(row/3), 3*(col/3), num)));
        }
        return ((!CheckRow(sudoku_grid, row, col, num))&&
        (!CheckCol(sudoku_grid, row, col, num))&&
        (!CheckDia1(sudoku_grid, row, col, num))&&
        (!CheckBox(sudoku_grid, row, col, 3*(row/3), 3*(col/3), num)));
    }

    if ((row+col) == 8)
    {
//tile belongs to diagonal 2
        return ((!CheckRow(sudoku_grid, row, col, num))&&
        (!CheckCol(sudoku_grid, row, col, num))&&
        (!CheckDia2(sudoku_grid, row, col, num))&&
        (!CheckBox(sudoku_grid, row, col, 3*(row/3), 3*(col/3), num)));
    }

//tile does not belong to either diagonal
    return ((!CheckRow(sudoku_grid, row, col, num))&&
    (!CheckCol(sudoku_grid, row, col, num))&&
    (!CheckBox(sudoku_grid, row, col, 3*(row/3), 3*(col/3), num)));

}

/* Returns a bool which indicates whether any assigned entry
in the specified tile is valid for window sudoku or not. */
bool CheckNumW(int sudoku_grid[9][9], int row, int col, int num)
{
//Check if num is not already placed in current row, coloumn and box
    if (((row==1)||(row==2)||(row==3))&&((col==1)||(col==2)||(col==3)))
    {
//tile belongs to window 1
        return ((!CheckRow(sudoku_grid, row, col, num))&&
        (!CheckCol(sudoku_grid, row, col, num))&&
        (!CheckBox(sudoku_grid, row, col, 1, 1, num))&&
        (!CheckBox(sudoku_grid, row, col, 3*(row/3), 3*(col/3), num)));
    }

    if (((row==1)||(row==2)||(row==3))&&((col==5)||(col==6)||(col==7)))
    {
//tile belongs to window 2
        return ((!CheckRow(sudoku_grid, row, col, num))&&
        (!CheckCol(sudoku_grid, row, col, num))&&
        (!CheckBox(sudoku_grid, row, col, 1, 5, num))&&
        (!CheckBox(sudoku_grid, row, col, 3*(row/3), 3*(col/3), num)));
    }

    if (((row==5)||(row==6)||(row==7))&&((col==1)||(col==2)||(col==3)))
    {
//tile belongs to window 3
        return ((!CheckRow(sudoku_grid, row, col, num))&&
        (!CheckCol(sudoku_grid, row, col, num))&&
        (!CheckBox(sudoku_grid, row, col, 5, 1, num))&&
        (!CheckBox(sudoku_grid, row, col, 3*(row/3), 3*(col/3), num)));
    }

     if (((row==5)||(row==6)||(row==7))&&((col==5)||(col==6)||(col==7)))
    {
//tile belongs to window 4
        return ((!CheckRow(sudoku_grid, row, col, num))&&
        (!CheckCol(sudoku_grid, row, col, num))&&
        (!CheckBox(sudoku_grid, row, col, 5, 5, num))&&
        (!CheckBox(sudoku_grid, row, col, 3*(row/3), 3*(col/3), num)));
    }
//tile does not belong to either windows
    return ((!CheckRow(sudoku_grid, row, col, num))&&
    (!CheckCol(sudoku_grid, row, col, num))&&
    (!CheckBox(sudoku_grid, row, col, 3*(row/3), 3*(col/3), num)));

}

/* Returns a bool which indicates whether any assigned entry
in the specified tile is valid for normal sudoku or not. */
bool CheckNumJ(jig sudoku, int row, int col, int num)
{
//Check if num is not already placed in current row, coloumn and box
    return ((!CheckRow(sudoku.grid, row, col, num))&&
    (!CheckCol(sudoku.grid, row, col, num)));

}

/* Returns a bool which indicates whether any assigned entry
in the specified row matches the given number. */
bool CheckRow(int sudoku_grid[9][9], int row, int col, int num)
{
    int index;
    for (index = 0; index < 9; index++)
    {
        if ((sudoku_grid[row][index] == num)&&(index!=col))
        {
//assigned entry is invalid in this row
            return true;
        }
    }
//assigned entry is valid in this row
    return false;
}

/* Returns a bool which indicates whether any assigned entry
in the specified coloumn matches the given number. */
bool CheckCol(int sudoku_grid[9][9], int row, int col, int num)
{
    int index;
    for (index = 0; index < 9; index++)
    {
        if ((sudoku_grid[index][col] == num)&&(index!=row))
        {
//assigned entry is invalid in this column
            return true;
        }
    }
//assigned entry is valid in this column
    return false;
}

/* Returns a bool which indicates whether any assigned entry
in the specified box matches the given number. */
bool CheckBox(int sudoku_grid[9][9], int row, int col, int rowstart, int colstart, int num)
{
int index1, index2;
    for (int index1 = 0; index1 < 3; index1++)
    {
        for (index2 = 0; index2 < 3; index2++)
        {
            if ((sudoku_grid[rowstart+index1][colstart+index2] == num)&&((rowstart+index1!=row)||(colstart+index2!=col)))
            {
//assigned entry is invalid in this box
                return true;
            }
        }
    }
//assigned entry is valid in this box
    return false;
}

/* Returns a bool which indicates whether any assigned entry
in the diagonal 1 matches the given number. */
bool CheckDia1(int sudoku_grid[9][9],int row, int col, int num)
{
    int index;
    for (index = 0; index < 9; index++)
    {
        if ((sudoku_grid[index][index] == num)&&(index!=col))
        {
//assigned entry is invalid in this diagonal
            return true;
        }
    }
//assigned entry is valid in this diagonal
    return false;
}

/* Returns a bool which indicates whether any assigned entry
in the diagonal 2 matches the given number. */
bool CheckDia2(int sudoku_grid[9][9],int row, int col, int num)
{
    int index;
    for (index = 0; index < 9; index++)
    {
        if ((sudoku_grid[index][(8-index)] == num)&&(index!=row))
        {
//assigned entry is invalid in this diagonal
            return true;
        }
    }
//assigned entry is valid in this diagonal
    return false;
}


//prints sudoku_grid
void DisplaySudoku(int sudoku_grid[9][9])
{
    int index1, index2;
    for (index1 = 0; index1 < 9; index1++)
    {
            for (int index2 = 0; index2 < 9; index2++)
            {
            cout<<sudoku_grid[index1][index2]<<" ";
            }
        cout<<endl;
    }
}

/*Returns an int which indicates whether the input
grid is a solution of the normal sudoku problem or not */
int CheckNSudoku(int sudoku_grid[9][9],int solved_grid[9][9])
{
    int row, col;
    for (row = 0; row < 9; row++)
    {
        for (col = 0; col < 9; col++)
        {
            if (solved_grid[row][col] == 0)
            {
//incomplete solution
                cout<<"Incomplete Solution";
                return -1;
            }

            if (((sudoku_grid[row][col] != 0)&&(sudoku_grid[row][col] !=solved_grid[row][col]))
                 ||(!CheckNumN(solved_grid,row,col,solved_grid[row][col])))
            {
//invalid solution
                return 0;
            }
        }
    }
    return 1;
}

/*Returns an int which indicates whether the input
grid is a solution of the diagonal sudoku problem or not */
int CheckDSudoku(int sudoku_grid[9][9],int solved_grid[9][9])
{
    int row, col;
    for (row = 0; row < 9; row++)
    {
        for (col = 0; col < 9; col++)
        {
            if (solved_grid[row][col] == 0)
            {
//incomplete solution
                cout<<"Incomplete Solution";
                return -1;
            }

            if (((sudoku_grid[row][col] != 0)&&(sudoku_grid[row][col] !=solved_grid[row][col]))
                 ||(!CheckNumW(solved_grid,row,col,solved_grid[row][col])))
            {
//invalid solution
                return 0;
            }
        }
    }
    return 1;
}

/*Returns an int which indicates whether the input
grid is a solution of the window sudoku problem or not */
int CheckWSudoku(int sudoku_grid[9][9],int solved_grid[9][9])
{
    int row, col;
    for (row = 0; row < 9; row++)
    {
        for (col = 0; col < 9; col++)
        {
            if (solved_grid[row][col] == 0)
            {
//incomplete solution
                cout<<"Incomplete Solution";
                return -1;
            }

            if (((sudoku_grid[row][col] != 0)&&(sudoku_grid[row][col] !=solved_grid[row][col]))
                 ||(!CheckNumW(solved_grid,row,col,solved_grid[row][col])))
            {
//invalid solution
                return 0;
            }
        }
    }
    return 1;
}

/*Returns an int which indicates whether the input
grid is a solution of the jigsaw sudoku problem or not */
int CheckJSudoku(jig &sudoku, jig &solved)
{


//initializing solved.present and checking solution
        int row, col;
    for (row = 0; row < 9; row++)
    {
        for (col = 0; col < 9; col++)
        {
            if (solved.grid[row][col] == 0)
            {
//incomplete solution
                cout<<"Incomplete Solution";
                return -1;
            }
        }
    }

    if (!(solved.InputPresent()))
    {
//Invalid solution
        return 0;
    }

    for (row = 0; row < 9; row++)
    {
        for (col = 0; col < 9; col++)
        {

            if (((sudoku.grid[row][col] != 0)&&(sudoku.grid[row][col] !=solved.grid[row][col]))
                 ||(!CheckNumJ(solved,row,col,solved.grid[row][col])))
            {
//invalid solution
                return 0;
            }
        }
    }
    return 1;
}

/*Returns a bool which inicates whether the the sudoku
grids are same or not */
bool CheckSame(int grid1[9][9], int grid2[9][9])
{
    int index1, index2;
    for (int index1 = 0; index1 < 9; index1++)
    {
        for (index2 = 0; index2 < 9; index2++)
        {
            if (grid1[index1][index2]!=grid2[index1][index2])
            {
//assigned entry is invalid in this box
                return false;
            }
        }
    }
//assigned entry is valid in this box
    return true;
}

/*Returns an int which inicates whether the the normal sudoku
has unique solution or non unique solution or no solution */
int NSudoku(int sudoku_grid[9][9])
{
    int grid[9][9];
//Input validation
    if (!ValidN(sudoku_grid))
    {
//input is invalid
        return -1;
    }
//Initializing grid
    CopyGrid(sudoku_grid,grid);

// no solution
    if(!SolveNSudoku(sudoku_grid,1)){return -1;}
    if(!SolveNSudoku(grid,-1)){return -1;}

    if(CheckSame(grid, sudoku_grid))
    {
//unique solution
     return 1;
    }
//non-unique solution
    return 0;
}

/*Returns an int which inicates whether the the diagonal sudoku
has unique solution or non unique solution or no solution */
int DSudoku(int sudoku_grid[9][9])
{
        int grid[9][9];
//Input validation
    if (!ValidD(sudoku_grid))
    {
//input is invalid
        return -1;
    }
//Initializing grid
    CopyGrid(sudoku_grid,grid);

// no solution
    if(!SolveDSudoku(sudoku_grid,1)){return -1;}
    if(!SolveDSudoku(grid,-1)){return -1;}

    if(CheckSame(grid, sudoku_grid))
    {
//unique solution
     return 1;
    }
//non-unique solution
    return 0;
}

/*Returns an int which inicates whether the the window sudoku
has unique solution or non unique solution or no solution */
int WSudoku(int sudoku_grid[9][9])
{
        int grid[9][9];
//Input validation
    if (!ValidW(sudoku_grid))
    {
//input is invalid
        return -1;
    }
//Initializing grid
    CopyGrid(sudoku_grid,grid);

// no solution
    if(!SolveWSudoku(sudoku_grid,1)){return -1;}
    if(!SolveWSudoku(grid,-1)){return -1;}

    if(CheckSame(grid, sudoku_grid))
    {
//unique solution
     return 1;
    }
//non-unique solution
    return 0;
}

/*Returns an int which inicates whether the the jigsaw sudoku
has unique solution or non unique solution or no solution */
int JSudoku(jig &sudoku)
{
    if (!ValidJ(sudoku))
    {
        return -1;
    }

    jig grid;
//Initializing grids
    grid = sudoku;

// no solution
    if(!SolveJSudoku(sudoku,1)){return -1;}
    if(!SolveJSudoku(grid,-1)){return -1;}

    if(CheckSame(grid.grid, sudoku.grid))
    {
//unique solution
     return 1;
    }
//non-unique solution
    return 0;
}

/*Returns a bool which indicates whether the input
grid is in accordance with normal sudoku */
bool ValidN(int sudoku_grid[9][9])
{
    for (int i = 0; i < 9; i++)
    {
        for (int j = 0; j < 9; j++)
        {

            if ((sudoku_grid[i][j]!=0)&&
            (!CheckNumN(sudoku_grid,i,j,sudoku_grid[i][j])))
            {
//input is invalid
                cout<<"Invalid Input";
                return false;
            }
        }
    }
    return true;
}

/*Returns a bool which indicates whether the input
grid is in accordance with diagonal sudoku */
bool ValidD(int sudoku_grid[9][9])
{
      for (int i = 0; i < 9; i++)
    {
        for (int j = 0; j < 9; j++)
        {

            if ((sudoku_grid[i][j]!=0)&&
            (!CheckNumD(sudoku_grid,i,j,sudoku_grid[i][j])))
            {
//input is invalid
                cout<<"Invalid Input";
                return false;
            }
        }
    }
    return true;
}

/*Returns a bool which indicates whether the input
grid is in accordance with window sudoku */
bool ValidW(int sudoku_grid[9][9])
{
        for (int i = 0; i < 9; i++)
    {
        for (int j = 0; j < 9; j++)
        {

            if ((sudoku_grid[i][j]!=0)&&
            (!CheckNumW(sudoku_grid,i,j,sudoku_grid[i][j])))
            {
//input is invalid
                cout<<"Invalid Input";
                return false;
            }
        }
    }
    return true;
}

/*Returns a bool which indicates whether the input
grid is in accordance with jigsaw sudoku */
bool ValidJ(jig &sudoku)
{
//Input validation
    for (int i = 0; i < 9; i++)
    {
        for (int j = 0; j < 9; j++)
        {

            if ((sudoku.grid[i][j]!=0)&&(!CheckNumJ(sudoku,i,j,sudoku.grid[i][j])))
            {
//input is invalid
                cout<<"Invalid Input";
                return false;
            }
        }
    }

//Initialize present
    if (!(sudoku.InputPresent()))
    {
//input is invalid
        cout<<"Invalid Input";
        return false;
    }

    return true;
}


#endif // SUDOKU_H_INCLUDED
